/* Generated by wayland-scanner 1.23.0 */

/*
 * Copyright © 2008-2011 Kristian Høgsberg
 * Copyright © 2010-2011 Intel Corporation
 * Copyright © 2012-2013 Collabora, Ltd.
 * Copyright © 2012, 2013 Intel Corporation
 * Copyright © 2015, 2016 Jan Arne Petersen
 * Copyright © 2017, 2018 Red Hat, Inc.
 * Copyright © 2018       Purism SPC
 * Copyright © 2021       Valve Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#include <stdbool.h>
#include <stdlib.h>
#include <stdint.h>
#include "wayland-util.h"

#ifndef __has_attribute
# define __has_attribute(x) 0  /* Compatibility with non-clang compilers. */
#endif

#if (__has_attribute(visibility) || defined(__GNUC__) && __GNUC__ >= 4)
#define WL_PRIVATE __attribute__ ((visibility("hidden")))
#else
#define WL_PRIVATE
#endif

extern const struct wl_interface gamescope_input_method_interface;
extern const struct wl_interface wl_seat_interface;

static const struct wl_interface *gamescope_input_method_types[] = {
	NULL,
	NULL,
	&wl_seat_interface,
	&gamescope_input_method_interface,
};

static const struct wl_message gamescope_input_method_manager_requests[] = {
	{ "destroy", "", gamescope_input_method_types + 0 },
	{ "create_input_method", "on", gamescope_input_method_types + 2 },
};

WL_PRIVATE const struct wl_interface gamescope_input_method_manager_interface = {
	"gamescope_input_method_manager", 3,
	2, gamescope_input_method_manager_requests,
	0, NULL,
};

static const struct wl_message gamescope_input_method_requests[] = {
	{ "destroy", "", gamescope_input_method_types + 0 },
	{ "commit", "u", gamescope_input_method_types + 0 },
	{ "set_string", "s", gamescope_input_method_types + 0 },
	{ "set_action", "u", gamescope_input_method_types + 0 },
	{ "pointer_motion", "3ff", gamescope_input_method_types + 0 },
	{ "pointer_warp", "3ff", gamescope_input_method_types + 0 },
	{ "pointer_wheel", "3ii", gamescope_input_method_types + 0 },
	{ "pointer_button", "3uu", gamescope_input_method_types + 0 },
};

static const struct wl_message gamescope_input_method_events[] = {
	{ "unavailable", "", gamescope_input_method_types + 0 },
	{ "done", "u", gamescope_input_method_types + 0 },
};

WL_PRIVATE const struct wl_interface gamescope_input_method_interface = {
	"gamescope_input_method", 3,
	8, gamescope_input_method_requests,
	2, gamescope_input_method_events,
};

